---
title: typeof
slug: Web/JavaScript/Reference/Operators/typeof
tags:
  - JavaScript
  - Language feature
  - Operator
  - Reference
  - Unary
---
<div>{{JSSidebar("Operators")}}</div>

<p>The <strong><code>typeof</code></strong> operator returns a string indicating the type of the unevaluated operand.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-typeof.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<p>The <code>typeof</code> operator is followed by its operand:</p>

<pre class="syntaxbox notranslate">typeof <var>operand</var>
typeof(<var>operand</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>operand</var></code></dt>
 <dd>An expression representing the object or <a href="/en-US/docs/Glossary/Primitive">primitive</a> whose type is to be returned.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The following table summarizes the possible return values of <code>typeof</code>. For more information about types and primitives, see also the <a href="/en-US/docs/Web/JavaScript/Data_structures">JavaScript data structure</a> page.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Type</th>
   <th scope="col">Result</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Glossary/Undefined">Undefined</a></td>
   <td><code>"undefined"</code></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/Null">Null</a></td>
   <td><code>"object"</code> (see <a href="#typeof_null">below</a>)</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/Boolean">Boolean</a></td>
   <td><code>"boolean"</code></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/Number">Number</a></td>
   <td><code>"number"</code></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/BigInt">BigInt</a> (new in ECMAScript 2020)</td>
   <td><code>"bigint"</code></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/String">String</a></td>
   <td><code>"string"</code></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/Symbol">Symbol</a> (new in ECMAScript 2015)</td>
   <td><code>"symbol"</code></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Glossary/Function">Function</a> object (implements [[Call]] in ECMA-262 terms)</td>
   <td><code>"function"</code></td>
  </tr>
  <tr>
   <td>Any other object</td>
   <td><code>"object"</code></td>
  </tr>
 </tbody>
</table>

<div class="notecard note">
<p><strong>Note:</strong> ECMAScript 2019 and older permitted implementations to have <code>typeof</code> return any implementation-defined string value for non-callable non-standard exotic objects.</p>

<p>The only known browser to have actually taken advantage of this is old Internet Explorer (see <a href="#IE-specific_notes">below</a>).</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_usage">Basic usage</h3>

<pre class="brush: js notranslate">// Numbers
typeof 37 === 'number';
typeof 3.14 === 'number';
typeof(42) === 'number';
typeof Math.LN2 === 'number';
typeof Infinity === 'number';
typeof NaN === 'number'; // Despite being "Not-A-Number"
typeof Number('1') === 'number';      // Number tries to parse things into numbers
typeof Number('shoe') === 'number';   // including values that cannot be type coerced to a number

typeof 42n === 'bigint';

// Strings
typeof '' === 'string';
typeof 'bla' === 'string';
typeof `template literal` === 'string';
typeof '1' === 'string'; // note that a number within a string is still typeof string
typeof (typeof 1) === 'string'; // typeof always returns a string
typeof String(1) === 'string'; // String converts anything into a string, safer than toString

// Booleans
typeof true === 'boolean';
typeof false === 'boolean';
typeof Boolean(1) === 'boolean'; // Boolean() will convert values based on if they're truthy or falsy
typeof !!(1) === 'boolean'; // two calls of the ! (logical NOT) operator are equivalent to Boolean()

// Symbols
typeof Symbol() === 'symbol'
typeof Symbol('foo') === 'symbol'
typeof Symbol.iterator === 'symbol'

// Undefined
typeof undefined === 'undefined';
typeof declaredButUndefinedVariable === 'undefined';
typeof undeclaredVariable === 'undefined';

// Objects
typeof {a: 1} === 'object';

// use <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/isArray">Array.isArray</a> or Object.prototype.toString.call
// to differentiate regular objects from arrays
typeof [1, 2, 4] === 'object';

typeof new Date() === 'object';
typeof /regex/ === 'object'; // See Regular expressions section for historical results

// The following are confusing, dangerous, and wasteful. Avoid them.
typeof new Boolean(true) === 'object';
typeof new Number(1) === 'object';
typeof new String('abc') === 'object';

// Functions
typeof function() {} === 'function';
typeof class C {} === 'function';
typeof Math.sin === 'function';</pre>

<h3 id="typeof_null"><code>typeof null</code></h3>

<pre class="brush: js; no-line-numbers notranslate">// This stands since the beginning of JavaScript
typeof null === 'object';</pre>

<p>In the first implementation of JavaScript, JavaScript values were represented as a type tag and a value. The type tag for objects was <code>0</code>. <code>null</code> was represented as the NULL pointer (<code>0x00</code> in most platforms). Consequently, <code>null</code> had <code>0</code> as type tag, hence the <code>typeof</code> return value <code>"object"</code>. (<a href="http://www.2ality.com/2013/10/typeof-null.html">reference</a>)</p>

<p>A fix was proposed for ECMAScript (via an opt-in), but <a class="external" href="https://web.archive.org/web/20160331031419/http://wiki.ecmascript.org:80/doku.php?id=harmony:typeof_null">was rejected</a>. It would have resulted in <code>typeof null === 'null'</code>.</p>

<h3 id="Using_new_operator">Using <code>new</code> operator</h3>

<pre class="brush: js; notranslate">// All constructor functions, with the exception of the Function constructor, will always be typeof 'object'
let str = new String('String');
let num = new Number(100);

typeof str; // It will return 'object'
typeof num; // It will return 'object'

let func = new Function();

typeof func; // It will return 'function'
</pre>

<h3 id="Need_for_parentheses_in_Syntax">Need for parentheses in Syntax</h3>

<pre class="brush:js notranslate">// Parentheses can be used for determining the data type of expressions.
let iData = 99;

typeof iData + ' Wisen'; // 'number Wisen'
typeof (iData + ' Wisen'); // 'string'
</pre>

<h3 id="Regular_expressions">Regular expressions</h3>

<p>Callable regular expressions were a non-standard addition in some browsers.</p>

<pre class="brush:js; no-line-numbers notranslate">typeof /s/ === 'function'; // Chrome 1-12 Non-conform to ECMAScript 5.1
typeof /s/ === 'object';   // Firefox 5+  Conform to ECMAScript 5.1</pre>

<h3 id="Errors">Errors</h3>

<p>Before ECMAScript 2015, <code>typeof</code> was always guaranteed to return a string for any operand it was supplied with. Even with undeclared identifiers, <code>typeof</code> will return <code>'undefined'</code>. Using <code>typeof</code> could never generate an error.</p>

<p>But with the addition of block-scoped {{JSxRef("Statements/let", "let")}} and {{JSxRef("Statements/const")}} using <code>typeof</code> on <code>let</code> and <code>const</code> variables (or using <code>typeof</code> on a <code>class</code>) in a block before they are declared will throw a {{JSxRef("ReferenceError")}}. Block scoped variables are in a "<a href="/en-US/docs/Web/JavaScript/Reference/Statements/let#The_temporal_dead_zone_and_typeof">temporal dead zone</a>" from the start of the block until the initialization is processed, during which, it will throw an error if accessed.</p>

<pre class="brush: js; no-line-numbers notranslate">typeof undeclaredVariable === 'undefined';

typeof newLetVariable; // ReferenceError
typeof newConstVariable; // ReferenceError
typeof newClass; // ReferenceError

let newLetVariable;
const newConstVariable = 'hello';
class newClass{};</pre>

<h3 id="Exceptions">Exceptions</h3>

<p>All current browsers expose a non-standard host object <a href="/en-US/docs/Web/API/Document/all" title="The Document interface's read-only all property returns an HTMLAllCollection rooted at the document node. In other words, it returns the entire contents of the page."><code>document.all</code></a> with type <code>undefined</code>.</p>

<pre class="brush: js; no-line-numbers notranslate">typeof document.all === 'undefined';</pre>

<p>Although the specification allows custom type tags for non-standard exotic objects, it requires those type tags to be different from the predefined ones. The case of <code>document.all</code> having type <code>'undefined'</code> is classified in the web standards as a "willful violation" of the original ECMA JavaScript standard.</p>

<h3 id="Real-world_usage">Real-world usage</h3>

<p><code>typeof</code> is very useful, but it's not as versatile as might be required. For example, <code>typeof([])</code> , is <code>'object'</code>, as well as <code>typeof(new Date())</code>, <code>typeof(/abc/)</code>, etc.</p>

<p>For greater specificity in checking types, a <code>typeof</code> wrapper for usage in production-level code would be as follows (provided <code>obj</code> exists):</p>

<pre class="brush: js notranslate">  function type(obj, fullClass) {

    // get toPrototypeString() of obj (handles all types)
    // Early JS environments return '[object Object]' for null, so it's best to directly check for it.
    if (fullClass) {
        return (obj === null) ? '[object Null]' : Object.prototype.toString.call(obj);
    }
    if (obj == null) { return (obj + '').toLowerCase(); } // implicit toString() conversion

    var deepType = Object.prototype.toString.call(obj).slice(8,-1).toLowerCase();
    if (deepType === 'generatorfunction') { return 'function' }

    // Prevent overspecificity (for example, [object HTMLDivElement], etc).
    // Account for functionish Regexp (Android &lt;=2.3), functionish &lt;object&gt; element (Chrome &lt;=57, Firefox &lt;=52), etc.
    // String.prototype.match is universally supported.

    return deepType.match(/^(array|bigint|date|error|function|generator|regexp|symbol)$/) ? deepType :
       (typeof obj === 'object' || typeof obj === 'function') ? 'object' : typeof obj;
  }</pre>

<p>For checking non-existent variables that would otherwise throw a {{JSxRef("ReferenceError")}}, use <code>typeof nonExistentVar === 'undefined'</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-typeof-operator', 'The typeof Operator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.typeof")}}</p>

<h3 id="IE-specific_notes">IE-specific notes</h3>

<p>On IE 6, 7, and 8 a lot of host objects are objects and not functions. For example:</p>

<pre class="brush: js; no-line-numbers notranslate">typeof alert === 'object'</pre>

<p>Some non-standard IE properties return other values (<a href="https://github.com/tc39/ecma262/issues/1440#issuecomment-461963872">tc39/ecma262#1440 (comment)</a>):</p>

<pre class="brush: js; no-line-numbers notranslate">typeof window.external.AddSearchProvider === "unknown";
typeof window.external.IsSearchProviderInstalled === "unknown";</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{JSxRef("Operators/instanceof", "instanceof")}}</li>
 <li><a href="https://github.com/tc39/ecma262/issues/668"><code>document.all</code> willful violation of the standard</a></li>
</ul>
